<?php
/*
 * Przykład na podstawie przykładu z książki: Ed Lecky-Thompson, Heow Eide-Goodman, Steven D. Nowicki, Alec Cove, PHP5. Zaawansowane Programowanie, Helion 2005
 */
class COsoba
{
	private $id;
	private $imie;
	private $nazwisko;
	private $zmodyfikowane=false;
	
	public function __construct( $id )
	{
		echo "Pobieram dane z bazy danych na podstawie id<br>";
		$this->imie="Jan";
		$this->nazwisko="Kowalski";
	}
	public function getImie() { return $this->imie; }
	public function getNazwisko() { return $this->nazwisko; }
	public function setImie( $imie )
	{
		$this->zmodyfikowane=( $this->imie!=$imie );
		$this->imie=$imie;		
	}
	public function setNazwisko( $nazwisko )
	{
		$this->zmodyfikowane=( $this->nazwisko!=$nazwisko );
		$this->nazwisko=$nazwisko;		
	}
	public function __destruct()
	{
		if ( $this->zmodyfikowane )
		{
			echo "Zapisuję zmiany do bazy danych<br>";
		}
		echo "Zamykam połączenie do bazy danych<br>";
	}
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>destruktory</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<style type="text/css">
td,th,body { font-family:Verdana, Arial, Helvetica, sans-serif; font-size:10pt; }
</style>
</head>

<body>

<?php
$o=new COsoba( 10 );
$o->setImie( "Ewa" );
$o->setNazwisko( "Nowak" );
$o=null;
?>

</body>
</html>