<?php
/*
 * Przykład na podstawie przykładu z książki: Adam Trachtenberg, PHP5. Nowe możliwości, Helion 2005
 */
class CAdres
{
	protected $miasto;
	protected $ulica;
	public function setMiasto( $miasto ) { $this->miasto=$miasto; }
	public function setUlica( $ulica ) { $this->ulica=$ulica; }
	public function getMiasto() { return $this->miasto; }
	public function getUlica() { return $this->ulica; }
}
class COsoba
{
	protected $imie;
	protected $nazwisko;
	protected $adres;
	
	public function __construct() { $this->adres=new CAdres(); }
	public function setImie( $imie ) { $this->imie=$imie; }
	public function setNazwisko( $nazwisko ) { $this->nazwisko=$nazwisko; }
	public function getImie() { return $this->imie; }
	public function getNazwisko() { return $this->nazwisko; }
	public function __call( $method, $args )
	{
		if ( method_exists( $this->adres, $method ) )
		{
			return call_user_func_array( array( $this->adres, $method ), $args );
		}
	}
	public function __clone() {
		//$this->adres=clone $this->adres;	
	}
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>magiczne2</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<style type="text/css">
td,th,body { font-family:Verdana, Arial, Helvetica, sans-serif; font-size:10pt; }
</style>
</head>

<body>

<?php
$o = new COsoba();
$o->setImie( "Jan" );
$o->setNazwisko( "Kowalski" );
$o->setMiasto( "Wrocław" );
$o->setUlica( "ul. Kwidzyńska 23/2" );
$p=clone( $o );
$p->setImie( "Edmund" );
$p->setNazwisko( "Nowak" );
$p->setMiasto( "Warszawa" );
$p->setUlica( "ul. Prosta 52/1" );
echo "{$o->getImie()} {$o->getNazwisko()}, zamieszkały  {$o->getMiasto()}, {$o->getUlica()}<br>";
echo "{$p->getImie()} {$p->getNazwisko()}, zamieszkały  {$p->getMiasto()}, {$p->getUlica()}";
?>

</body>
</html>