<?php
class A
{
	public $poleA1;
	protected $poleA2;
	private $poleA3;
	
	function __construct($a, $b, $c)
	{
		$this->poleA1=$a;
		$this->poleA2=$b;
		$this->poleA3=$c;
		print("Robi się A"."<br>");
	}
	
	function info()
	{
		print($this->poleA1."<br>");
		print($this->poleA2."<br>");
		print($this->poleA3."<br>");
	}
}

class B extends A
{
	public $poleB1 = "public B";
	protected $poleB2 = "protected B";
	private $poleB3 = "private B";

	function __construct()
	{
		parent::__construct("public A", "protected A", "private A");
		print("Robi się B"."<br>");
	}
	function __destruct()
	{
		print("Psujemy sie"."<br>");
	}
	
	function info()
	{
		parent::info();
		print($this->poleA1."<br>"); // OK
		print($this->poleA2."<br>"); // OK
		print($this->poleA3."<br>"); // Undefined
		print($this->poleB1."<br>");
		print($this->poleB2."<br>");
		print($this->poleB3."<br>");
	}
}

class C extends B
{
	const stala="wartosc stalej.<br>";
	//function __construct()
	//{
	//}
	public static $pole = "napis<br>"; 
	static function wypisz()
	{
		echo "ala ma kota<br>";
		echo self::$pole;
		echo self::stala;
	}
	function info()
	{
		self::wypisz();
		parent::info();
	}
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>pogmatwany</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<style type="text/css">
td,th,body { font-family:Verdana, Arial, Helvetica, sans-serif; font-size:10pt; }
</style>
</head>

<body>

<?php
  $b = new B();
  $b->info();
  $c = new C();
  $c->info();
  
?>

Tu jest międzyczasie<br>

</body>
</html> 